active: true
volatile: true
intents:
    initComplaint:
        type: command
        initial: true
        condition: content == "goToComplain"
    postBackComplaint:
        type: data
        initial: true
        condition: payload.menu == "complaint"
    phone:
        type: text
        initial: false
        fallback: false
        classifier:
            nlu: supermodel
            match: phone
            options:
                labels: true
        attributes:
            phone:
                nlu: supermodel
                path: phone
    email:
        type: text
        initial: false
        fallback: false
        classifier:
            nlu: supermodel
            match: email
            options:
                labels: true
        attributes:
            email:
                nlu: supermodel
                path: email
    store:
        type: text
        initial: false
        fallback: false
        classifier:
            nlu: supermodel
            match: location
            options:
                labels: true
        attributes:
            store:
                nlu: supermodel
                path: location
    datetime:
        type: text
        initial: false
        fallback: false
        classifier:
            nlu: supermodel
            match: datetime
            options:
                labels: true
        attributes:
            datetime:
                nlu: supermodel
                path: datetime
    cancel:
        type: text
        initial: false
        fallback: false
        classifier:
            nlu: cancelKeyword
            match: cancel
    reenter:
        type: command
        initial: false
        fallback: false
        condition: content == "reenter"
    toEmail:
        type: command
        initial: false
        fallback: false
        condition: content == "goToEmail"
    toDate:
        type: command
        initial: false
        fallback: false
        condition: content == "goToDate"
    fallback:
        type: text
        initial: false
        fallback: true
        priority: -5
states:
    init:
        transitions:
            goToGreetings:
                fallback: false
                condition: "!data.name"
            complaintIntro:
                fallback: true
                mapping: 
                    data:
                        toState: "'askComplain'"
        initial: true
        end: false
    goToGreetings:
        end: true
        action:
            -
              name: toGreetings
    complaintIntro:
        enter:
            data:
                toState: "'cobaCheck'"
        transitions:
            checkEmailPhone:
                fallback: true
                mapping:
                    context:
                        complaintTxt: "content"
            complaintIntro:
                fallback: true
        action:
            -
              name: complaintIntro
            -
              name: complaintIntro-2 
    checkEmailPhone:
        transitions:
            askEmail:
                fallback: true
                condition: intent == "toEmail"
                mapping:
                    data:
                        toState: "'noEmail'"
            askDate:
                condition: intent == "toDate"
                mapping:
                    data:
                        toState: "'haveEmail'"
        action:
            -
              name: toDate
              condition: data.phone && data.email
            -
              name: toEmail 
              condition: (!data.phone || !data.email)
    askEmail:
        transitions:
            askPhone:
                condition: intent == "email"
                mapping:
                    data:
                        email: attributes.email
            askEmail:
                fallback: true
        action:
            - name: saySorry
              condition: intent != "fallback"
            - name: askEmail
              condition: intent != "fallback"
            - name: askEmail-2
              condition: intent != "fallback"
            - name: fallbackEmail
              condition: intent == "fallback"
    askPhone:
        transitions:
            askDate:
                condition: intent == "phone"
                mapping:
                    data:
                        phone: attributes.phone
            askPhone:
                fallback: true
        action:
            - name: saySorry
              condition: intent != "fallback"
            - name: askPhone
              condition: intent != "fallback"
            - name: fallbackPhone
              condition: intent == "fallback"
    askDate:
        transitions:
            askStoreLocation:
                  condition: intent == "datetime"
                  mapping:
                      context:
                          datetime: attributes.datetime
            askDate:
                fallback: true
        action:
            - name: saySorry
              condition: intent != "fallback"
            - name: askDate
              condition: intent != "fallback"
            - name: fallbackDate
              condition: intent == "fallback"
    askStoreLocation:
        transitions:
            showComplaintSummary:
                  condition: intent == "store"
                  mapping:
                      context:
                          store: attributes.store
            askStoreLocation:
                fallback: true
        action:
            - name: askStore
              condition: intent != "fallback"
            - name: fallbackStore
              condition: intent == "fallback"

    showComplaintSummary:
        end: true
        exit: 
            mapping:
                data:
                    toState: "null"
        action:
            -
              name: showComplaintSummary
            -
              name: sayThanks
            -
              name: toAskMore
    cancel:
        action: toAskMore
        float:
            condition: intent == "cancel"
            fallback: true
            priority: 10
        end: true
actions:
    toGreetings:
        type: command
        options:
            command: goToGreetings
    complaintIntro:
        type: text
        options:
            text: Ada kritik dan saran yang bisa Mr. J bantu sampaikan ke KFC?
    complaintIntro-2:
        type: text
        options:
            text: Silakan ketik pesan yang ingin kamu sampaikan
    toEmail:
        type: command
        options:
            command: goToEmail
    toDate:
        type: command
        options:
            command: goToDate
    saySorry:
        type: text
        options:
            text: 'Mohon maaf atas ketidaknyamanannya'
    askEmail:
        type: text
        options:
            text: 'Mr. J udah catat, nih'
    askEmail-2:
        type: text
        options:
            text: 'Aku minta email kamu ya, agar tim KFC bisa segera menangani kritik atau saran yang kamu sampaikan'
    fallbackEmail:
        type: text
        options:
            text: 'Kayanya kamu memasukkan email yang salah deh'
    askPhone:
        type: text
        options:
            text: Tulis nomor telepon kamu yang aktif juga ya
    fallbackPhone:
        type: text
        options:
            text: 'Kayanya kamu memasukkan phone yang salah deh'
    askDate:
        type: text
        options:
            text: 'Tanggal berapa kejadian tersebut terjadi, $(data.name)?'
    fallbackDate:
        type: text
        options:
            text: '... tanggal itu kayanya engga ada deh'
    askStore:
        type: text
        options:
            text: 'Lalu, di restoran KFC mana keluhan/masukan tersebut terjadi?'
    fallbackStore:
        type: text
        options:
            text: '... kayanya itu mekdi deh bukan KFC'
    showComplaintSummary:
        type: text
        options:
            text: |-
                    Aku bisa bantu rekap keluhanmu ya:
                    name : $(data.name)
                    store : $(context.store)
                    phone : $(data.phone)
                    email : $(data.email)
                    complaint : $(context.complaintTxt)
                    datetime : $(context.datetime)
    sayThanks:
        type: text
        options:
            text: 'Terima kasih! Kritik dan saranmu akan ditindaklanjuti oleh tim KFC'
    toAskMore:
        type: command
        options:
            command: goToAskMore
methods: {}
